/*
 * botcmds.c -- part of botnetop.mod
 *    
 * $Id: botcmds.c,v 1.7 2001/02/13 18:23:24 sup Exp $
 */
/*
 * Copyright (C) 2000, 2001  Teemu Hjelt <temex@iki.fi>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

static void bnop_askbot(char *hand, char *chname)
{
  int i;
  char data[256];
  struct chanset_t *chan = NULL;
  struct userrec *u;

  if ((chan = findchan_by_dname(chname)) && (ismember(chan, botname)) && (isop(botname, chan))) {
    u = get_user_by_handle(userlist, hand);
    if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname)) && (!matchattr(u, "d|d", chan->dname))) {
      i = nextbot(hand);
      if (i >= 0) {
        egg_snprintf(data, sizeof data, "doyawantops %s %s", chan->dname, botname);
        botnet_send_zapf(i, botnetnick, hand, data);
      }
    }
  }
}

static void bnop_reqop(char *chname) 
{
  int i;
  char data[256];
  tand_t *bot;
  struct chanset_t *chan = NULL;
  struct userrec *u;

  if ((chan = findchan_by_dname(chname))) {
    for (bot = tandbot; bot; bot = bot->next) {
      u = get_user_by_handle(userlist, bot->bot);
      if ((handisop(bot->bot, chan)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(bot->bot);
        if (i >= 0) {
          egg_snprintf(data, sizeof data, "reqops %s", chan->dname);
          botnet_send_zapf(i, botnetnick, bot->bot, data);
        }
      }
    }
  }
}

static void bnop_letmein(char *needthis, char *chname)
{
  int i;
  int bots = 0;
  char data[256];
  tand_t *bot;
  struct chanset_t *chan = NULL;
  struct needs_t *n = NULL;
  struct userrec *u;

  if ((!(chan = findchan_by_dname(chname))) || (ismember(chan, botname)))
    return;
  if (!(n = find_needs(chname)))
    n = add_needs(chname);
  if (!egg_strcasecmp(needthis, "needkey")) {
    if (n->key)
      return;
    for (bot = tandbot; bot; bot = bot->next) {
      u = get_user_by_handle(userlist, bot->bot);
      if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(bot->bot);
        if (i >= 0) {
          egg_snprintf(data, sizeof data, "wantkey %s %s", chan->dname, botname);
          botnet_send_zapf(i, botnetnick, bot->bot, data);
          bots++;
        }
      }
    }
    n->key = 1;
    n->k_time = now;
    if ((bop_log >= 1) && (bots > 0))
      putlog(LOG_MISC, "*", "botnetop.mod: requested key for %s from %d bot%s", chan->dname, bots, bots == 1 ? "" : "s");
  } else if (!egg_strcasecmp(needthis, "needinvite")) {
    if (n->invite)
      return;
    for (bot = tandbot; bot; bot = bot->next) {
      u = get_user_by_handle(userlist, bot->bot);
      if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(bot->bot);
        if (i >= 0) {
          if (botuserhost[0]) 
            egg_snprintf(data, sizeof data, "wantinvite %s %s %s", chan->dname, botname, strchr("~+-^=", botuserhost[0]) ? botuserhost + 1 : botuserhost);
          else
            egg_snprintf(data, sizeof data, "wantinvite %s %s", chan->dname, botname);
          botnet_send_zapf(i, botnetnick, bot->bot, data);
          bots++;
        }
      }
    }
    n->invite = 1;
    n->i_time = now;
    if ((bop_log >= 1) && (bots > 0))
      putlog(LOG_MISC, "*", "botnetop.mod: requested invite to %s from %d bot%s", chan->dname, bots, bots == 1 ? "" : "s");
  } else if (!egg_strcasecmp(needthis, "needlimit")) {
    if (n->limit)
      return;
    for (bot = tandbot; bot; bot = bot->next) {
      u = get_user_by_handle(userlist, bot->bot);
      if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(bot->bot);
        if (i >= 0) {
          egg_snprintf(data, sizeof data, "wantlimit %s %s", chan->dname, botname);
          botnet_send_zapf(i, botnetnick, bot->bot, data);
          bots++;
        }
      }
    }
    n->limit = 1;
    n->l_time = now;
    if ((bop_log >= 1) && (bots > 0))
      putlog(LOG_MISC, "*", "botnetop.mod: requested limit raise on %s %d bot%s", chan->dname, bots, bots == 1 ? "" : "s");
  } else if (!egg_strcasecmp(needthis, "needunban")) {
    if (n->unban)
      return;
    for (bot = tandbot; bot; bot = bot->next) {
      u = get_user_by_handle(userlist, bot->bot);
      if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(bot->bot);
        if (i >= 0) {
          egg_snprintf(data, sizeof data, "wantunban %s %s %s!%s", chan->dname, botname, botname, botuserhost);
          botnet_send_zapf(i, botnetnick, bot->bot, data);
          bots++;
        }
      }
    }
    n->unban = 1;
    n->u_time = now;
    if ((bop_log >= 1) && (bots > 0))
      putlog(LOG_MISC, "*", "botnetop.mod: requested unban on %s from %d bot%s", chan->dname, bots, bots == 1 ? "" : "s");
  }
}
